//#include <iostream>
//#include <sstream>
//#include <vector>
//#include <thread>
//#include <mutex>
//#include <queue>
//#include <cstring>
//#include <netinet/in.h>
//#include <unistd.h>
//#include <arpa/inet.h>
//#include<map>
//std::queue<char*> data;
//std::map<int, std::thread::id> socket_thread_id; // 使用int代替SOCKET
//std::map<int, std::string> socket_ip_address;
//std::mutex dataMutex;
//std::mutex sendMutex;
//
//static std::string printThreadId() {
//    std::thread::id this_id = std::this_thread::get_id();
//    std::stringstream ss;
//    ss << this_id;
//    return ss.str();
//}
//
//static void get_socket_thread_id(int sockConn, std::map<int, std::thread::id>& socket_thread_id) {
//    std::thread::id this_id = std::this_thread::get_id();
//    if (socket_thread_id.find(sockConn) == socket_thread_id.end()) {
//        socket_thread_id[sockConn] = this_id;
//    }
//}
//
//void HandleClient(int sockConn, const sockaddr_in& addrClient, std::map<int, std::thread::id>& socket_thread_id) {
//    char sendBuf[50];
//    if (inet_ntop(AF_INET, &(addrClient.sin_addr), sendBuf, sizeof(sendBuf)) == NULL) {
//        std::cerr << "inet_ntop failed\n";
//        close(sockConn);
//        return;
//    }
//   
//
//    int flag = true;
//    while (1) {
//        if (flag) {
//            std::cout << "连接来自：" << sockConn << "   Welcome " << sendBuf << " to here!\n";
//            flag = false;
//            get_socket_thread_id(sockConn, socket_thread_id);
//            std::string ip_address(sendBuf);
//            socket_ip_address[sockConn] = ip_address;//存储ip地址
//            // 获取锁的顺序：dataMutex -> sendMutex
//            dataMutex.lock();
//            sendMutex.lock();
//            send(sockConn, sendBuf, strlen(sendBuf) + 1, 0);
//            sendMutex.unlock();
//            dataMutex.unlock();
//        }
//
//        char recvBuf[1025];
//        int bytesReceived = recv(sockConn, recvBuf, sizeof(recvBuf), 0); //接受信息
//
//        if (bytesReceived <= 0) {
//            std::cerr << "Connection closed or error occurred.\n";
//            break;
//        }
//        recvBuf[bytesReceived] = '\0'; // 添加字符串结束符
//        std::cout << "接受到信息：" << recvBuf << std::endl;
//
//
//        for (auto& it : socket_thread_id) { //将信息发送给每一个客户端
//            if (it.second != std::this_thread::get_id()) //如果目标客户端是自身，则跳过
//            {
//                std::string chat_data(recvBuf);
//                chat_data.insert(0, "\n来自" + socket_ip_address[sockConn] + ":\n");
//                chat_data.append("\n");
//
//                int bytesSent = send(it.first, chat_data.c_str(), std::strlen(chat_data.c_str()) + 1, 0);
//                if (bytesSent == -1) {
//                    std::cerr << "send failed\n";
//                }
//                else {
//                    std::cout << "发送给：" << it.first << std::endl;
//                }
//            }
//        }
//
//        dataMutex.lock();
//        data.push(strdup(recvBuf));
//        dataMutex.unlock();
//    }
//
//    socket_thread_id.erase(sockConn);
//    close(sockConn);
//}
//
//int main() {
//    int sockSrv = socket(AF_INET, SOCK_STREAM, 0);
//    if (sockSrv == -1) {
//        std::cerr << "socket creation failed\n";
//        return 1;
//    }
//
//    sockaddr_in addrSrv;
//    addrSrv.sin_addr.s_addr = htonl(INADDR_ANY);
//    addrSrv.sin_family = AF_INET;
//    addrSrv.sin_port = htons(6000);
//
//    if (bind(sockSrv, reinterpret_cast<struct sockaddr*>(&addrSrv), sizeof(addrSrv)) == -1) {
//        std::cerr << "bind failed\n";
//        close(sockSrv);
//        return 1;
//    }
//
//    if (listen(sockSrv, 5) == -1) {
//        std::cerr << "listen failed\n";
//        close(sockSrv);
//        return 1;
//    }
//
//    std::vector<std::thread> threads;
//
//    while (true) {
//        sockaddr_in addrClient;
//        socklen_t addrLen = sizeof(addrClient);
//        int sockConn = accept(sockSrv, reinterpret_cast<struct sockaddr*>(&addrClient), &addrLen);
//        if (sockConn == -1) {
//            std::cerr << "accept failed\n";
//            continue;
//        }
//
//        // 创建一个新线程来处理客户端连接
//        threads.emplace_back(HandleClient, sockConn, addrClient, std::ref(socket_thread_id));
//        //调整sockConn就可以实现多客户端
//    }
//
//    // 关闭服务器套接字
//    close(sockSrv);
//
//    return 0;
//}
